<template>
  <article>
    <base-scroll-animation
      :type="'fade'"
      :delay="250"
      :duration="2500"
      :once="true"
    >
      <template v-slot:animate>
        <div class="flex is-spaced:between overflow-scroll-x" ref="items">
          <div v-for="(image, i) in images" :key="i" class="scroll-item">
            <img :src="getImage(image.url)" :alt="image.name" />
          </div>
        </div>
        <div class="range-container">
          <input
            type="range"
            min="0"
            max="100"
            value="0"
            class="range"
            ref="range"
          />
        </div>
      </template>
    </base-scroll-animation>
  </article>
</template>

<script>
export default {
  created() {
    window.addEventListener("resize", () => {
      this.handleScroll();
    });
    window.addEventListener("load", () => {
      this.handleScroll();
    });
  },
  beforeUnmount() {
    window.removeEventListener("resize", () => {
      this.handleScroll();
    });
    window.removeEventListener("load", () => {
      this.handleScroll();
    });
  },
  mounted() {
    this.handleScroll();
  },
  data() {
    return {
      images: [
        {
          url: "am_dagger_flower.png",
          name: "Dagger and Flowers"
        },
        {
          url: "am-jesus.jpg",
          name: "Jesus Portrait"
        },
        {
          url: "am_rose.png",
          name: "Rose"
        }
      ]
    };
  },
  methods: {
    handleScroll() {
      const scroll = this.$refs.range;
      const panel = this.$refs.items;
      if (document.body.clientWidth <= 601) {
        scroll.oninput = function() {
          let total = panel.scrollWidth - panel.offsetWidth;
          let percentage = total * (this.value / 100);
          panel.scrollLeft = percentage;
        };

        panel.onscroll = function() {
          let panelWidth = panel.scrollWidth - panel.offsetWidth;
          let total = panel.scrollLeft / panelWidth;
          let percentage = total * 100;
          scroll.value = percentage;
        };
      }
    },
    getImage(path) {
      return require(`@/assets/img/${path}`);
    }
  }
};
</script>

<style lang="scss" scoped>
.range-container {
  margin: 20px 0 0;
  padding: 0 10px;
  display: block;
  @media all and (min-width: 601px) {
    display: none;
  }
}
img {
  object-fit: contain;

  @media all and (min-width: 601px) {
    margin-bottom: 0;
  }
  @media all and (min-width: 1680px) {
    min-height: 53rem;
  }
}
</style>
